记我安装Caffe的血泪史(2)

不知不觉居然花了一个星期来安装Caffe。。。真是醉了。

接上一篇blog,本以为编译完cuda,opencv之后问题就差不多了(其实本来是没有什么问题的,但硬是被我搞了一堆事情出来....)

出于对作死的热爱,本人没有选择官方的Caffe进行安装,而是选择了一位韩国大兄弟diy过的Caffe。

然后就是疯狂的报错...一瞬间报错4000行你敢不敢信?多得终端都显示不完...由于我是中文的ubuntu,报错里面还是一堆乱码。

研究了许久没有结果之后我把调试信息的输出改成中文,然后将编译信息输出到文件里....

然而着这并没有什么卵用(妈个鸡)

这是上星期四的安装进度...

一直跳票到前天下午,我,又回来了,面对4000行的报错信息...

这4000行的报错是什么样的呢...

undefined reference to `std::basic_string<char, std::char_traits<char>, std::allocator<char> >::basic_string()

就是它!Caffe里几乎所有的cpp代码都报了这个错!

机智的我首先想到是不是编译器版本不对...

于是我把gcc5,gcc4.9,gcc4.8,gcc4.7(包括g++)都试了一遍....

然并卵....

而且网上居然没有人说在安装Caffe的时候遇到过这个问题

本来我也考虑过是不是这位大兄弟的Caffe有问题...所以我也把官方的Caffe也下了下来...

但是...由于Makfile和Makefile.configure需要修改,所以我把这位兄弟的Makefile拷到了官方的Caffe里面...

然后官方的Caffe也报出了一样的错...

你应该已经猜到了...没错,就是这位兄弟的Makefile !

当我把官方原版的Makefile从github上拷下来之后...错误果然没有了!!!

现在的错误变成了

 undefined reference to `google::protobuf::io::CodedOutputStream::WriteStringWithSizeToArray(std::string const&, unsigned char*)

然而这个错误其实是我自找的....

因为之前报错的时候我怀疑是protobuf的问题...然后我用gcc4.9重新编译了一遍protobuf....

于是我用gcc5编译Caffe的时候果断出错了..

然而我用gcc5重新编译了一遍protobuf之后还是报错...

MDZZ

最后发现是自己忘记make clean了...

所以gcc4.9编译出来的protobuf反复被install上去...真是醉了

其实遇到了很多问题...不过记不太清了...有的问题bing一下就解决了,改改Makefile,配置文件就行了

,有的问题和上述差不多,就是gcc版本不对...

我遇到的最多的问题就是gcc的版本冲突问题,这个很重要,搞清楚了这个caffe的安装就轻松多了。

因为gcc4到gcc5的变化非常大,如果依赖的编译和Caffe的编译使用不同的编译器的话就会报

undefined reference(未定义的引用) to XXXX

所以最好从头到尾使用一个gcc编译器,编译opencv,cuda,caffe,以及所有依赖

在这里给一些tip,希望后来人小心。

1 cuda8 支持gcc5 但是cuda8以下不支持(或者说会出问题,github上有人这么说的,我没试过)

2 ubuntu15.10,16.04通过apt-get安装的都是用gcc5编译过的软件包,在15.10之下的ubuntu通过apt-get应该默认安装gcc4编译的软件包

3 必要的时候就去官网上下载依赖项源码自己手动编译...手动编译并不麻烦(虽然我手动编译之后都在自找麻烦)

4 遇到问题不要百度,百度一下,真的会死!不能google就用bing,不要搜中文,注意看github和stackouflow还有google group上的问题和回答,非常有帮助!

时间: 10-20

记我安装Caffe的血泪史(2)的相关文章

【记录】在MAC上安装caffe

---恢复内容开始--- 最近尝试在MAC(OS X 10.11 El Capitan)上安装Caffe 以及Python接口遇到了一些问题但是官方安装教程上并没有提出这些问题的解决办法搜索了很久(主要在于Python接口上) 终于找到了解决办法 其实Caffe的安装分两步:安装依赖+编译源码 首先是安装依赖: [必要依赖]: 官方推荐用homebrew来安装: brew install -vd snappy leveldb gflags glog szip lmdb # 添加science源来

ubuntu16.04 安装 caffe cuda 相关流程

不多说了,经历了很多莫名其妙的错误最后终于安装好了,直接放安装脚本: #!/bin/bash #安装时要注意有些库可能安装失败以及安装caffe有和protobuf相关错误时可能需要重新对protobuf进行make install cd /home/zw/softwares #需要事先下载对应版本的cuda sudo dpkg -i cuda-repo-ubuntu1604-8-0-local-ga2_8.0.61-1_amd64.deb sudo apt-get update sudo ap

mac安装caffe

http://www.jianshu.com/p/cc16e2977e27 http://blog.csdn.net/q1w2e3r4470/article/details/47000643 http://blog.csdn.net/tracer9/article/details/50455353 http://www.zhimengzhe.com/mac/327058.html http://blog.csdn.net/feitongxunke/article/details/51388212

caffe:mac10.12安装caffe的步骤

前言:caffe官网中安装caffe时涉及的东西比较多而杂乱,其实有些东西可以忽略掉. 步骤: mac10.12本身自带了python2.7,可以使用系统自带的python 1.安装Homebrew: 在终端中输入  ruby -e "$(curl -fsSL https://raw.githubusercontent.com/Homebrew/install/master/install)" 2.安装caffe需要用到的一些依赖库,在终端中依次输入下面几行 brew install

安装caffe时遇到的各种问题

2017/5/15 caffe的编译过程 装好了cuda和cudnn之后,接下来就是对caffe文件的编译 首先下载一个BVLC/caffe的安装包,解压为caffe-master这个文件夹 然后cd到caffe-master这个目录下,运行下面的指令,相当于新建Makefile.config这个文件并且将Makefile.config.example的内容复制到Makefile.config中, cp Makefile.config.example Makefile.config 然后运行下面

virtualenv 下安装caffe教程

1.首先安装依赖环境, % sudo apt-get install libprotobuf-dev libleveldb-dev libsnappy-dev libopencv-dev libhdf5-serial-dev libgflags-dev libgoogle-glog-dev liblmdb-dev protobuf-compiler libatlas-base-dev % sudo apt-get install --no-install-recommends libboost-

在windows系统上安装caffe

确认电脑上有VS2013 确认显卡GPU Compute Capability>=3.0 安装CUDA7.5 下载cuDNN v4,添加到CUDA7.5 根据https://github.com/Microsoft/caffe进行安装 需要下载的附加包已传到百度云 NugetPackages 与caffe文件夹并列存放 运行测试结果如图

ubuntu14.04安装caffe+matlab

Linux安装----下载ubuntu14.04安装就可以了. gcc降级 sudo apt-get install -y gcc-4.7   // 下载gcc 4.7 sudo apt-get install -y g++-4.7 // 下载g++4.7 cd /use/bin sudo rm gcc  // 删除gcc sudo ln -s gcc-4.7 gcc  //链接 sudo rm g++ sudo ln -s g++-4.7 g++ sudo ldconfig git安装和caf

win7 64 旗舰版虚拟GPU-VMware下+vs2013安装caffe+matlab+python

转发请说明来处 Win7配置caffe(无GPU) 配置环境: 必须:win7 64 + vs2013 Win7 64位旗舰版要升级到service spack(因为是在vs2013下,想安装vs2013,得将旗舰版升级到Service Pack1),如下图 Vs2013 本人申请的服务器,无GPU,如图: 计算机-属性-设备管理器 (如果你的是NVIDIA,需要下载CUDA,不着急下面先看) 本人python2.7.12(不是安装的anaconda,当然建议安装这个) Matlab2016a